<div class="main-container">
  <div class="header-section">
    <app-page-header [pageInfo]="pageHeaderInfo"></app-page-header>
  </div>
  <div class="contact-form-container">
    <form [formGroup]="form" class="centered-form" (ngSubmit)="send()">
      <div class="form-content">
        <div class="columns">
          <div class="column is-12-mobile is-2-tablet is-3-desktop">
            <span class="section-title" i18n="@@contact.identity">Identity</span>
          </div>
        </div>
        <div class="columns">
          <div class="column is-12-mobile is-10-tablet is-12-desktop">
            <div class="prefilled-user-identity-column" *ngIf="user !== null; else unauthenticatedUserTemplate">
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 23 23" class="user-icon">
                <g>
                  <path
                    d="M11.5 11.7c-3.1 0-5.6-2.6-5.6-5.6C5.9 3 8.5.5 11.5.5c3.1 0 5.6 2.6 5.6 5.6 0 3-2.6 5.6-5.6 5.6zM17.2 14.6c1.3.6 2.3 1.5 3 2.6 1.2 1.9 1.2 3.8 1.2 3.9 0 .8-.6 1.4-1.2 1.4H2.6c-.6 0-1.2-.6-1.2-1.4 0-.1 0-2 1.2-3.9.7-1.1 1.8-2 3-2.6 1.6-.8 3.5-1.2 5.8-1.2s4.2.4 5.8 1.2z"
                    class="stroke-white" />
                </g>
              </svg>
              <div class="fields-container">
                <p class="fullname">{{ user.firstName }} {{ user.lastName }}</p>
                <p>{{ user.email }}</p>
              </div>
            </div>
            <ng-template #unauthenticatedUserTemplate>
              <div class="fields-container">
                <div class="columns">
                  <div class="field column is-6">
                    <label class="label" for="lastname"><span i18n="@@contact.lastname">Last name</span><span
                        class="required-field">*</span></label>
                    <p class="control has-icons-right">
                      <input id="lastname" class="input" type="text" formControlName="lastname" [attr.autocomplete]="'family-name'"
                        (keyup)="toUppercase('lastname')"
                        [ngClass]="{'has-error': fieldIsInvalid('lastname'), 'is-valid': fieldIsValid('lastname')}">
                      <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('lastname')">
                        <span class="fas fa-check-circle"></span>
                      </span>
                      <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('lastname')">
                        <span class="fas fa-exclamation-circle"></span>
                      </span>
                    </p>

                    <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('lastname')">
                      <div *ngIf="lastname.errors['required']" i18n="@@contact.errors.missingLastname">
                        You must indicate a lastname.
                      </div>
                      <div *ngIf="lastname.errors['pattern']" i18n="@@contact.errors.forbiddenCharacters">
                        Special characters are forbidden.
                      </div>
                    </div>
                  </div>

                  <div class="field column is-6">
                    <label class="label" for="firstname"><span i18n="@@contact.firstname">First name</span><span
                        class="required-field">*</span></label>
                    <p class="control has-icons-right">
                      <input id="firstname" class="input" type="text" (keyup)="toUppercase('firstname')"
                        formControlName="firstname" [attr.autocomplete]="'given-name'"
                        [ngClass]="{'has-error': fieldIsInvalid('firstname'), 'is-valid': fieldIsValid('firstname')}">
                      <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('firstname')">
                        <span class="fas fa-check-circle"></span>
                      </span>
                      <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('firstname')">
                        <span class="fas fa-exclamation-circle"></span>
                      </span>
                    </p>

                    <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('firstname')">
                      <div *ngIf="firstname.errors['required']" i18n="@@contact.errors.missingFirstname">
                        You must indicate a firstname.
                      </div>
                      <div *ngIf="firstname.errors['pattern']" i18n="@@contact.errors.forbiddenCharacters">
                        Special characters are forbidden.
                      </div>
                    </div>
                  </div>
                </div>
                <div class="columns">
                  <div class="field column is-6">
                    <label class="label" for="email"><span i18n="@@contact.email">Email</span><span
                        class="required-field">*</span></label>
                    <p class="control has-icons-right">
                      <input id="email" class="input" type="email" formControlName="email" [attr.autocomplete]="'email'"
                        [ngClass]="{'has-error': fieldIsInvalid('email'), 'is-valid': fieldIsValid('email')}">
                      <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('email')">
                        <span class="fas fa-check-circle"></span>
                      </span>
                      <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('email')">
                        <span class="fas fa-exclamation-circle"></span>
                      </span>
                    </p>

                    <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('email')">
                      <div *ngIf="email.errors['required']" i18n="@@contact.errors.missingEmail">
                        You must enter an email address.
                      </div>

                      <div *ngIf="email.errors['email']" i18n="@@contact.errors.invalidEmail">
                        You must enter a valid email address.
                      </div>
                    </div>
                  </div>

                  <div class="field column is-6">
                    <label class="label" for="emailConfirmation"><span i18n="@@contact.emailConfirmation">Confirm your
                        email
                        address</span><span class="required-field">*</span></label>
                    <p class="control has-icons-right">
                      <input id="emailConfirmation" class="input" type="email" formControlName="emailConfirmation" [attr.autocomplete]="'email'"
                        [ngClass]="{'has-error': emailConfirmationError || fieldIsInvalid('emailConfirmation'), 'is-valid': !emailConfirmationError && fieldIsValid('emailConfirmation')}">
                      <span class="icon is-small is-right is-icon-success"
                        *ngIf="!emailConfirmationError && fieldIsValid('emailConfirmation')">
                        <span class="fas fa-check-circle"></span>
                      </span>
                      <span class="icon is-small is-right is-icon-warning"
                        *ngIf="emailConfirmationError || fieldIsInvalid('emailConfirmation')">
                        <span class="fas fa-exclamation-circle"></span>
                      </span>
                    </p>

                    <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('emailConfirmation')">
                      <div *ngIf="emailConfirmation.errors['required']"
                        i18n="@@contact.errors.missingConfirmationEmail">
                        You must confirm your email address.
                      </div>

                      <div *ngIf="emailConfirmation.errors['email']" i18n="@@contact.errors.invalidEmail">
                        You must enter a valid email address.
                      </div>
                    </div>
                    <div class="form-incorrect-field-message" *ngIf="emailConfirmationError">
                      <div *ngIf="emailConfirmationError" i18n="@@contact.errors.confirmationEmailNotCorresponding">
                        You must enter the same email address.
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </ng-template>
          </div>
        </div>
      </div>
      <div class="form-content">
        <div class="columns">
          <div class="column is-12">
            <span class="section-title" i18n="@@contact.message">Message</span>
          </div>
        </div>
        <div class="columns">
          <div class="column is-12">
            <div class="field">
              <label class="label" [for]="subjectLabelFor"><span i18n="@@contact.subject">Subject</span><span
                  class="required-field">*</span></label>
              <div class="dropdown" [ngClass]="{'is-active': subjectDropdownState}"
                (clickOutside)="closeSubjectDropdown()">
                <div class="dropdown-trigger" (click)="toggleSubject()">
                  <button id="subjectDropdown" type="button" class="button" aria-haspopup="true"
                    aria-controls="dropdown-menu" [disabled]="formDisabled">
                    <span>{{ selectedSubject !== null && selectedSubject.value !== null ? selectedSubject.value : contactTrad.subjectPlaceholder }}</span>
                    <span class="icon is-small">
                      <span class="fas fa-angle-down" aria-hidden="true"></span>
                    </span>
                  </button>
                </div>
                <div class="dropdown-menu" id="dropdown-menu" role="menu">
                  <ul class="dropdown-content">
                    <li class="dropdown-item" *ngFor="let sub of subjects" (keydown.enter)="setSubject(sub)"
                      (click)="setSubject(sub)" tabindex=0>
                      {{ sub.value }}
                    </li>
                  </ul>
                </div>
              </div>
              <p class="control has-icons-right subject-input-control" *ngIf="displaySubjectInput === true">
                <input id="subjectInput" class="input" type="text" formControlName="subject"
                  [ngClass]="{'has-error': fieldIsInvalid('subject'), 'is-valid': fieldIsValid('subject')}">
                <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('subject')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('subject')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('subject')">
                <div *ngIf="subject.errors['required']" i18n="@@contact.errors.missingSubject">
                  You must enter a subject.
                </div>
              </div>
            </div>

            <div class="field">
              <label class="label" for="text"><span i18n="@@contact.messageField">Message</span><span
                  class="required-field">*</span></label>
              <p class="control has-icons-right">
                <textarea id="text" class="textarea has-fixed-size" type="textarea" formControlName="text"
                  [ngClass]="{'has-error': fieldIsInvalid('text'), 'is-valid': fieldIsValid('text')}" rows=6></textarea>
                <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('text')">
                  <span class="fas fa-check-circle"></span>
                </span>
                <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('text')">
                  <span class="fas fa-exclamation-circle"></span>
                </span>
              </p>

              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('text')">
                <div *ngIf="text.errors['required']" i18n="@@contact.errors.invalidMessage">
                  You must enter a message.
                </div>
              </div>
            </div>


            <div class="field">
              <input id="consent" class="is-checkradio" type="checkbox" formControlName="consent">
              <label for="consent" class="label consent-label checkbox-label">
                <p>
                  <span i18n="@@consent.withoutCGU">I accept the processing of the information
                    entered in this form to respond to my request.</span><span class="required-field">*</span>
                </p>
              </label>
              <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('consent')">
                <div *ngIf="consent.errors['required']" i18n="@@consent.error">
                  You must accept the processing of the information entered in this form to
                  respond to your request.
                </div>
              </div>
              <p class="consent-text" i18n="@@consent.contact.text">
                According to French Law ≪ Informatique et Libertés ≫ concerning data processing and individual liberties,
                registration and use of your personal datas are necessary to answer your questions.
                You allow « data.grandlyon.com » to collect and use your datas by clicking the box « I accept the processing of the information entered in this form to respond to my request. ». Data collected are: e-mail, firstname, lastname.
                Recipients of these personal datas are, with strict respect of goals mentionned above,
                responsible departements of Metropole de Lyon and its service providers.
                You have the right to access, correct and delete the personal data.
                When a consent is required for a processing, you have the right to revoke it.
                Under some regulary conditions, you have the right to ask for processing limitation or to get opposed to it.
                To exercise these rights, you can contact the Délégué à la Protection des Données by mail at :
                Métropole de Lyon – Délégué à la Protection des Données – Direction des Affaires Juridiques et de la Commande Publique – 20, rue du Lac – BP 33569 – 69505 Lyon Cedex 03
                or by form at : https://demarches.toodego.com/sve/proteger-mes-donnees-personnelles/.
                For any demand about collecting or processing of your personal datas, you can contact the Délégué à la Protection des Données (DPD), whose adress is mentionned above.
                For strong conflicts concerning your personal datas, you have the right to alert the CNIL [supervisory authority] which address is : Commission Nationale Informatique et Libertés, 3 place de Fontenoy 75007 Paris, 01 53 73 22 22, https://www.cnil.fr/fr/vous-souhaitez-contacter-la-cnil
              </p>
            </div>
          </div>
        </div>
      </div>
      <div class="columns">
        <div class="column is-12">
          <div class="button-wrapper">
            <button class="button btn-red-text" type="button" [disabled]="formDisabled" (click)="cancel()"
              i18n="@@contact.cancel">Cancel</button>
            <button type="submit" class="button button-gl" [ngClass]="{'is-loading': formDisabled}"
              [disabled]="formIsInvalid || formDisabled" i18n="@@contact.send">Send</button>
          </div>
        </div>
      </div>
    </form>
  </div>
</div>
